function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import Builder from './Builder';

var BooleanBuilder = function (_Builder) {
  _inheritsLoose(BooleanBuilder, _Builder);

  function BooleanBuilder(defaultValue) {
    return _Builder.call(this, 'boolean', defaultValue || false) || this;
  }

  var _proto = BooleanBuilder.prototype;

  _proto.onlyFalse = function onlyFalse() {
    this.defaultValue = false;
    this.addCheck(this.checkOnlyFalse);
    return this;
  };

  _proto.checkOnlyFalse = function checkOnlyFalse(path, value) {
    if ("production" !== process.env.NODE_ENV) {
      this.invariant(value === false, 'May only be `false`.', path);
    }
  };

  _proto.onlyTrue = function onlyTrue() {
    this.defaultValue = true;
    this.addCheck(this.checkOnlyTrue);
    return this;
  };

  _proto.checkOnlyTrue = function checkOnlyTrue(path, value) {
    if ("production" !== process.env.NODE_ENV) {
      this.invariant(value === true, 'May only be `true`.', path);
    }
  };

  return BooleanBuilder;
}(Builder);

export { BooleanBuilder as default };
export function bool(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }

  return new BooleanBuilder(defaultValue);
}