import isObject from './isObject';
export default function typeOf(value) {
  if (Array.isArray(value)) {
    return value.every(function (item) {
      return typeof item === typeof value[0];
    }) ? 'array' : 'union';
  }

  if (isObject(value)) {
    return value.constructor === Object ? 'object' : 'instance';
  }

  switch (typeof value) {
    case 'boolean':
    case 'function':
    case 'number':
    case 'string':
      return typeof value;

    default:
      return 'unknown';
  }
}