import Builder from './Builder';
export default class StringBuilder<T extends string = string> extends Builder<T> {
    constructor(defaultValue?: T);
    camelCase(): this;
    contains(token: string, index?: number): this;
    checkContains(path: string, value: T, token: string, index?: number): void;
    kebabCase(): this;
    match(pattern: RegExp, message?: string): this;
    checkMatch(path: string, value: T, pattern: RegExp, message?: string): void;
    notEmpty(): this;
    checkNotEmpty(path: string, value: T): void;
    oneOf<U extends string>(list: U[]): StringBuilder<U>;
    checkOneOf(path: string, value: T, list: T[]): void;
    pascalCase(): this;
    snakeCase(): this;
}
export declare function string<T extends string = string>(defaultValue?: string): StringBuilder<T>;
