"use strict";

exports.__esModule = true;
exports.default = typeOf;

var _isObject = _interopRequireDefault(require("./isObject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function typeOf(value) {
  if (Array.isArray(value)) {
    return value.every(function (item) {
      return typeof item === typeof value[0];
    }) ? 'array' : 'union';
  }

  if ((0, _isObject.default)(value)) {
    return value.constructor === Object ? 'object' : 'instance';
  }

  switch (typeof value) {
    case 'boolean':
    case 'function':
    case 'number':
    case 'string':
      return typeof value;

    default:
      return 'unknown';
  }
}